function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return _typeof(key) === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (_typeof(input) !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (_typeof(res) !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
import init from "./init.js";
import { REMEMBER_REHYDRATED, REMEMBER_PERSISTED } from "./action-types.js";
import { combineReducers } from 'redux';
export * from "./types.js";
var rememberReducer = function rememberReducer(reducer) {
  var data = {
    state: {}
  };
  return function () {
    var _action$type;
    var state = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : data.state;
    var action = arguments.length > 1 ? arguments[1] : undefined;
    if (action.type && ((action === null || action === void 0 ? void 0 : action.type) === '@@INIT' || action !== null && action !== void 0 && (_action$type = action.type) !== null && _action$type !== void 0 && _action$type.startsWith('@@redux/INIT'))) {
      data.state = _objectSpread({}, state);
    }
    var rootReducer = typeof reducer === 'function' ? reducer : combineReducers(reducer);
    switch (action.type) {
      case REMEMBER_REHYDRATED:
        {
          var rehydratedState = _objectSpread(_objectSpread({}, data.state), action.payload || {});
          data.state = rootReducer(rehydratedState, {
            type: REMEMBER_REHYDRATED,
            payload: rehydratedState
          });
          return data.state;
        }
      default:
        return rootReducer(state, action);
    }
  };
};
var rememberEnhancer = function rememberEnhancer(driver, rememberedKeys) {
  var _ref = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {},
    _ref$prefix = _ref.prefix,
    prefix = _ref$prefix === void 0 ? '@@remember-' : _ref$prefix,
    _ref$serialize = _ref.serialize,
    serialize = _ref$serialize === void 0 ? function (data, key) {
      return JSON.stringify(data);
    } : _ref$serialize,
    _ref$unserialize = _ref.unserialize,
    unserialize = _ref$unserialize === void 0 ? function (data, key) {
      return JSON.parse(data);
    } : _ref$unserialize,
    _ref$persistThrottle = _ref.persistThrottle,
    persistThrottle = _ref$persistThrottle === void 0 ? 100 : _ref$persistThrottle,
    persistDebounce = _ref.persistDebounce,
    _ref$persistWholeStor = _ref.persistWholeStore,
    persistWholeStore = _ref$persistWholeStor === void 0 ? false : _ref$persistWholeStor,
    initActionType = _ref.initActionType;
  if (!driver) {
    throw Error('redux-remember error: driver required');
  }
  if (!Array.isArray(rememberedKeys)) {
    throw Error('redux-remember error: rememberedKeys needs to be an array');
  }
  var storeCreator = function storeCreator(createStore) {
    return function (rootReducer, initialState, enhancer) {
      var isInitialized = false;
      var initialize = function initialize(store) {
        return init(store, rememberedKeys, {
          driver: driver,
          prefix: prefix,
          serialize: serialize,
          unserialize: unserialize,
          persistThrottle: persistThrottle,
          persistDebounce: persistDebounce,
          persistWholeStore: persistWholeStore
        });
      };
      var store = createStore(function (state, action) {
        if (!isInitialized && initActionType && action.type === initActionType) {
          isInitialized = true;
          setTimeout(function () {
            return initialize(store);
          }, 0);
        }
        return rootReducer(state, action);
      }, initialState, enhancer);
      if (!initActionType) {
        isInitialized = true;
        initialize(store);
      }
      return store;
    };
  };
  return storeCreator;
};
export { rememberReducer, rememberEnhancer, REMEMBER_REHYDRATED, REMEMBER_PERSISTED };
//# sourceMappingURL=index.js.map