"use strict";

function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.rehydrate = exports.loadAllKeyed = exports.loadAll = void 0;
var _actionTypes = require("./action-types");
var _utils = require("./utils");
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return _typeof(key) === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (_typeof(input) !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (_typeof(res) !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }
function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }
var loadAll = exports.loadAll = /*#__PURE__*/function () {
  var _ref2 = _asyncToGenerator(function* (_ref) {
    var rememberedKeys = _ref.rememberedKeys,
      driver = _ref.driver,
      prefix = _ref.prefix,
      unserialize = _ref.unserialize;
    var data = yield driver.getItem("".concat(prefix, "rootState"));
    if (data === null || data === undefined) {
      return {};
    }
    return (0, _utils.pick)(unserialize(data, 'rootState'), rememberedKeys);
  });
  return function loadAll(_x) {
    return _ref2.apply(this, arguments);
  };
}();
var loadAllKeyed = exports.loadAllKeyed = /*#__PURE__*/function () {
  var _ref4 = _asyncToGenerator(function* (_ref3) {
    var rememberedKeys = _ref3.rememberedKeys,
      driver = _ref3.driver,
      prefix = _ref3.prefix,
      unserialize = _ref3.unserialize;
    var items = yield Promise.all(rememberedKeys.map(function (key) {
      return driver.getItem("".concat(prefix).concat(key));
    }));
    return rememberedKeys.reduce(function (obj, key, i) {
      if (items[i] !== null && items[i] !== undefined) {
        obj[key] = unserialize(items[i], key);
      }
      return obj;
    }, {});
  });
  return function loadAllKeyed(_x2) {
    return _ref4.apply(this, arguments);
  };
}();
var rehydrate = exports.rehydrate = /*#__PURE__*/function () {
  var _ref6 = _asyncToGenerator(function* (store, rememberedKeys, _ref5) {
    var prefix = _ref5.prefix,
      driver = _ref5.driver,
      persistWholeStore = _ref5.persistWholeStore,
      unserialize = _ref5.unserialize;
    var state = store.getState();
    try {
      var load = persistWholeStore ? loadAll : loadAllKeyed;
      state = _objectSpread(_objectSpread({}, state), yield load({
        rememberedKeys: rememberedKeys,
        driver: driver,
        prefix: prefix,
        unserialize: unserialize
      }));
    } catch (err) {
      console.warn('redux-remember: rehydrate error', err);
    }
    store.dispatch({
      type: _actionTypes.REMEMBER_REHYDRATED,
      payload: state
    });
  });
  return function rehydrate(_x3, _x4, _x5) {
    return _ref6.apply(this, arguments);
  };
}();
//# sourceMappingURL=rehydrate.js.map